#!/usr/bin/env python


import serial, string, binascii

HEADER = (0x80)
ECU_ID = (0x10)
DIAGNOSTIC_TOOL_ID = (0xF0)
READ_PADDING = (0x00)
READ_MEMORY_COMMAND = (0xA0)
READ_MEMORY_RESPONSE = (0xE0)
READ_ADDRESS_COMMAND = (0xA8)
READ_ADDRESS_RESPONSE = (0xE8)
WRITE_MEMORY_COMMAND = (0xB0)
WRITE_MEMORY_RESPONSE = (0xF0)
WRITE_ADDRESS_COMMAND = (0xB8)
WRITE_ADDRESS_RESPONSE = (0xF8)
ECU_INIT_COMMAND = (0xBF)
ECU_INIT_RESPONSE = (0xFF)
COM_PORT = '/dev/ttyUSB0'


def GenChecksum(ByteList):
	checksumTotal = 0
	s = ''
	for i in ByteList:
		checksumTotal = checksumTotal + i
	if checksumTotal < 0:
		return "-" + alt_bin(-checksumTotal)
	while checksumTotal != 0:
		if checksumTotal % 2 == 0: 
			bit = '0'
		else:
			bit = '1'
		if  len(s) < 8:
			s = bit + s
		checksumTotal >>= 1
	return int(s, base=2)


def ByteToHex( byteStr ):     
    return ''.join( [ "%02X " % ord( x ) for x in byteStr ] ).strip()

def ECUInit():
	ser = serial.Serial(COM_PORT, 4800, 8, 'N', 1, timeout=.1)
	cmdByteStr = ""
	header = [HEADER, ECU_ID, DIAGNOSTIC_TOOL_ID]
	command = ECU_INIT_COMMAND
	cmd = []
	for el in header:
		cmd.append(el)
	cmd.append(1)
	cmd.append(command)
	cmd.append(GenChecksum(cmd))
	for i in cmd:
		cmdByteStr = cmdByteStr + chr(i)
	print cmdByteStr
	print ByteToHex(cmdByteStr)
	line = cmdByteStr	
	while line == cmdByteStr:
		x = ser.write(cmdByteStr)
		line = ser.readline()
		print line
		print str(ByteToHex(line))


def ECUReadAddress():
	ser = serial.Serial(COM_PORT, 4800, 8, 'N', 1, timeout=.1)
	cmdByteStr = ""
	header = [HEADER, ECU_ID, DIAGNOSTIC_TOOL_ID]
	command = READ_ADDRESS_COMMAND
	payLoad = [(0x08),(0x1C)]
	cmd = []
	for el in header:
		cmd.append(el)
	cmd.append(len(payLoad)*4)
	cmd.append(command)
	cmd.append(READ_PADDING)
	for el in payLoad:
		cmd.append(READ_PADDING)
		cmd.append(READ_PADDING)
		cmd.append(READ_PADDING)
		cmd.append(el)
	cmd.append(GenChecksum(cmd))
	for i in cmd:
		cmdByteStr = cmdByteStr + chr(i)
	print cmdByteStr
	print ByteToHex(cmdByteStr)	
	x = ser.write(cmdByteStr)
	line = ser.readline()
	print line
	print str(ByteToHex(line))
          
if __name__ == "__main__":
	ECUInit()
	ECUReadAddress()
